<script setup lang="ts">
import type { Ref } from 'vue'
import { useEditorStore } from 'store/editorStore'
import { useSettingsStore } from 'store/settingsStore'
import { useErrorStore } from 'store/errorStore'

type drawerTypes = 'error' | 'warning'

const editorStore = useEditorStore()
const settingsStore = useSettingsStore()
const errorStore = useErrorStore()

// Data Reference Modal Handling
const showModal = ref(false)

// Error Drawer Handling
const drawerType: Ref<drawerTypes> = ref('warning')
const drawerActive = ref(false)
const activate = (type: drawerTypes) => {
  drawerActive.value = true
  drawerType.value = type
}
</script>

<template>
  <div
    id="statusbar"
    class="h8 flex w-[100vw] items-center justify-between bg-gray-50 border-t-1 px-4 border-gray-200 text-sm leading-none"
  >
    <div id="stats" class="flex items-center space-x-sm">
      <div id="email-name">
        <span>Email Name: </span>
        <span :class="{ 'text-error font-semibold': !settingsStore.email_name }">
          {{ settingsStore.email_name || 'Untitled' }}
        </span>
      </div>
      <n-divider vertical />
      <div id="status">
        <span>Current Status: </span>
        {{ settingsStore.is_published ? 'Published' : 'Draft' }}
      </div>
      <n-divider vertical />
      <div id="last-updated">
        <span>Last Updated: </span>
        <n-time :time="settingsStore.email_last_updated_at" :to="new Date()" type="relative" />
      </div>
      <n-divider vertical />
      <div id="position" class="self-center">
        <!-- Line and Column Number -->
        <span>Ln {{ editorStore.getLineNumber || '0' }}, Col {{ editorStore.getColumnNumber || '0' }}</span>
      </div>
      <n-divider vertical />
    </div>
    <div id="support" class="flex items-stretch space-x-sm">
      <div id="tag-reference" class="flex">
        <n-button text type="primary" size="small" class="!hover:bg-gray !hover:bg-opacity-10 px-2" @click="showModal = true">
          <span>Data Tag Reference</span>
        </n-button>
        <TagReference v-model="showModal" />
      </div>
      <n-divider vertical />
      <div id="error-drawer" class="flex items-center">
        <!-- Error Drawer -->
        <n-button text class="!hover:bg-gray !hover:bg-opacity-10 px-1" :class="{ '!bg-gray-200 !bg-opacity-20': drawerActive }" @click="activate('warning')">
          <template #icon>
            <i role="img" class="i-ant-design:warning-outlined block w-5 h-5 text-warning" />
          </template>
          <span class="font-semibold text-xs text-warning">{{ errorStore.getWarnings.length }}</span>
        </n-button>
        <n-button text class="!hover:bg-gray !hover:bg-opacity-10 px-1" :class="{ '!bg-gray-200 !bg-opacity-20': drawerActive }" @click="activate('error')">
          <template #icon>
            <i role="img" class="i-ant-design:bug-outlined block w-5 h-5 text-error" />
          </template>
          <span class="font-semibold text-xs text-error">{{ errorStore.getErrors.length }}</span>
        </n-button>
      </div>
    </div>
  </div>
  <ErrorDrawer v-model="drawerActive" :drawer-type="drawerType" />
</template>
